; version 2.0

; HL = (A * HL * 2) / 256
; actually (A * HL / 128) - saves more precision
mul_s16_s8s16_m2d256
	ld b,0
	ld e,a : rlc e : jp nc,mul_s16_s8s16_m2d256_1
	neg : inc b
mul_s16_s8s16_m2d256_1
	ld e,a : ld d,0
	ld a,h : rlca : jp nc,mul_s16_s8s16_m2d256_2
	;; + neg_hl
	ld a,h : cpl : ld h,a
	ld a,l : cpl : ld l,a
	inc hl
	;; - neg_hl
	inc b
mul_s16_s8s16_m2d256_2
	;; + mul_s16_s16s16
	ld a,h
	ld c,l
	ld hl,0
	dup 16
		add hl,hl
		rl c
		rla
		jr nc,$+3
		add hl,de
		; $+3
	edup
	;; - mul_s16_s16s16
	xor a
	add hl,hl
	ld l,h
	rla : ld h,a
	rrc b
	ret nc
	;; + neg_hl
	ld a,h : cpl : ld h,a
	ld a,l : cpl : ld l,a
	inc hl
	;; - neg_hl
	ret

; HL = (A * H * 4) / 256
mul_s16_s8s8_m4d256
	ld b,0
	ld l,a : rlc l : jp nc,mul_s16_s8s8_m4d256_1
	neg : inc b
mul_s16_s8s8_m4d256_1
	ld e,a : ld d,0
	ld a,h : rlc h : jp nc,mul_s16_s8s8_m4d256_2
	neg : inc b
mul_s16_s8s8_m4d256_2
	ld l,a : ld h,0
	;; + mul_u16_u16u16
	ld a,h
	ld c,l
	ld hl,0
	dup 16
		add hl,hl
		rl c
		rla
		jr nc,$+3
		add hl,de
		; $+3
	edup
	;; - mul_u16_u16u16
	xor a
	add hl,hl
	rla
	add hl,hl
	rla
	ld l,h : ld h,a
	rrc b
	ret nc
	;; + neg_hl
	ld a,h : cpl : ld h,a
	ld a,l : cpl : ld l,a
	inc hl
	;; - neg_hl
	ret

; HL = A * HL
mul_s16_s8s16
	call expand_a_de
	; jp mul_s16_s16s16

; HL = HL * DE
; A,C = UNDEF
mul_s16_s16s16
mul_u16_u16u16
	ld a,h
	ld c,l
	ld hl,0
	dup 16
		add hl,hl
		rl c
		rla
		jr nc,$+3
		add hl,de
		; $+3
	edup
	ret

; H'L'HL = B'C'BC * D'E'DE
; A = UNDEF
mul_u32_u32u32
mul_s32_s32s32
	ld hl,0
	exx
	ld hl,0
	;;
	dup 32
	sra b
	rr c
	exx
	rr b
	rr c
	jr nc,$+7
	add hl,de
	exx
	adc hl,de
	exx
	; $+7
	sla e
	rl d
	exx
	rl e
	rl d
	edup
	;;
	exx
	ret

; L,D,E = HL * DE
mul_s24_s16s16
	ld b,h : ld c,l
	exx : ld bc,0 : exx
	rlc h
	jp nc,mul_s24_s16s16_1
	exx : dec b : dec c : exx
mul_s24_s16s16_1
	exx : ld de,0 : exx
	ld a,d : rlca
	jp nc,mul_s24_s16s16_2
	exx : dec d : dec e : exx
mul_s24_s16s16_2
	call mul_u32_u32u32
	ld d,h : ld e,l
	exx : ld a,l : exx : ld l,a
	ret

; HL = H * E
; D = 0
mul_u16_u8u8
	ld l,0 : ld d,l
	sla h
	jr nc,$+3
	ld l,e
	; $+3
	dup 7
	add hl,hl
	jr nc,$+3
	add hl,de
	; $+3
	edup
	ret
